<?php
namespace Teknisa\CRM\Controller;

use Teknisa\CRM\Controller\TeknisaCrud;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Teknisa\Model\Util\NovoCodigo;

class InterProspectController extends TeknisaCrud {
    protected $dataSourceName = 'Interpros_prospect';
    protected $leadService;
    
    public function __construct ($crudService, $parameterBag, $leadService){
        $this->parameterBag  = $parameterBag;
        $this->leadService   = $leadService;

        parent::__construct($crudService, $parameterBag);
    }
    
    public function setInteprosp(DTO\Request\DataSet $request, DTO\Response $response) {
        try {
            foreach ($request->getDataSet()->getRows() as &$row) {
                if (array_key_exists('CDINTEPROS', $row)) {
                    if ($row['__is_new']) {
                        $row['CDINTEPROS'] = $this->leadService->callForGetNewProspInterlocutorCode(array("NRORG" => $row['NRORG'], "CDPROSPECT" => $row['CDPROSPECT']));
                    }
                } else {
                    $row['CDINTEPROS'] = $this->leadService->callForGetNewProspInterlocutorCode(array("NRORG" => $row['NRORG'], "CDPROSPECT" => $row['CDPROSPECT']));
                }
            
            }
            parent::save($request, $response);
        } catch(\Exception $e) {
            $response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), $e->getCode()));
        }
    }
}
?>