<?php
namespace Teknisa\CRM\Controller;

use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\ParameterBag;
use Teknisa\Model\Util\NovoCodigo;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Teknisa\CRM\Controller\TeknisaCrud;

class crm00110000motievolcontcontroller extends TeknisaCrud {
    protected $dataSourceName = 'motievolcont';
    
    public function __construct($crudService, $parameterBag, $zhFileUploader){
		$this->zhFileUploader = $zhFileUploader;
		
		parent::__construct($crudService, $parameterBag);
	}
    
    public function setMotivoEvolCont(DTO\Request\DataSet $request, DTO\Response $response) {
        try {
            foreach ($request->getDataSet()->getRows() as &$row) {
                if (array_key_exists('CDMOTIEVOCON', $row)) {
                    if ($row['__is_new']) {
                        $row['CDMOTIEVOCON'] = NovoCodigo::geraCodigo($row['NRORG'], "MOTIEVOLCONT", 1, 5, false, true);
                    }
                } else {
                    $row['CDMOTIEVOCON'] = NovoCodigo::geraCodigo($row['NRORG'], "MOTIEVOLCONT", 1, 5, false, true);
                }
                $row['DSCAMINHOANEXOPADRAO'] = empty($row['DSCAMINHOANEXOPADRAO']) ? '' : $row['DSCAMINHOANEXOPADRAO'];
                $row['NMANEXOPADRAO']        = empty($row['NMANEXOPADRAO']) ? '' : $row['NMANEXOPADRAO'];
                /*Se tiver Anexo na row, deleta o último arquivo, salva o novo e salva o novo link na row*/
                if(!empty($row['ATTACHMENT'])){
                    if(!empty($row['DSCAMINHOANEXOPADRAO']))
                        $this->zhFileUploader->deleteFile($row["DSCAMINHOANEXOPADRAO"]);
                        
                    $this->uploadFile($row);
                }
            }
            parent::save($request, $response);
        } catch(\Exception $e) {
            $response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), $e->getCode()));
        }
    }
    
    private function uploadFile(&$row){
        $attachment = $row['ATTACHMENT'][0];
        $file = array(
            'FILE' => array(
                array(
                    "name" => $attachment['name'],
                    "type" => explode('.', $attachment['name'])[1],
                    "b64File" => $attachment['b64File'],
                    "size" => $attachment['size']
                )
            )    
        );
        $this->zhFileUploader->uploadFilesInRow($file, 'FILE', 'crm_anexomotivo');
        $row['DSCAMINHOANEXOPADRAO'] = $file['FILE'][0]['path'];
        $row['NMANEXOPADRAO']        = $attachment['name'];
    }
}