var properties = ['__metadata', 'widgets', 'fields','actions', 'groupMenu', 'menus'];

function isZeedhiObject(objName){
    return ~properties.indexOf(objName);
}

function isDeveloperObject(obj, objName){
    return !objName || obj.hasOwnProperty("isFolder");
}

function isZeedhiOrDeveloperObject(obj, objName){
    return isDeveloperObject(obj, objName) || isZeedhiObject(objName);
}

function getProperties(obj){
    var props = properties.filter(function(property){
        return obj.hasOwnProperty(property);
    });
    props = props.length ? props : Object.keys(obj);
    return props;
}

function applyFunctionToObject(obj, f, objName){
    if(Array.isArray(obj)){
        obj.map(function(object){
            applyFunctionToObject(object, f, objName);
        });
    } else if(Util.isObject(obj) && isZeedhiOrDeveloperObject(obj, objName)){
        obj = f(obj);
        getProperties(obj).forEach(function(property){
            if(obj[property]){
                obj[property] = applyFunctionToObject(obj[property], f, property);
            }
        });
    }
    return obj;
}

function setPropertyShowInDevTools(obj){
    obj.showInDevTools = true;
    return obj;
}

function deletePropertyShowInDevTools(obj){
    if(obj.showInDevTools) delete obj.showInDevTools;
    return obj;
}

var ShowInDevTools = {
    setTree: function(object){
        return applyFunctionToObject(object, setPropertyShowInDevTools);
    },
    clear: function(object){
        return applyFunctionToObject(object, deletePropertyShowInDevTools);
    }
};